import { ComponentConstructor } from 'preact';
import { Dispatcher } from './dispatcher';
import { Cmd } from './cmd';
export interface Message<K, V = any, E extends Error = any> {
    kind: K;
    value: V;
    error: E;
}
export interface ComponentDefinition<Model, Msg extends Message<any>, Props> {
    update(model: Model | undefined, msg: Msg): Model | [Model, Cmd<Msg['kind']>];
    view(model: Model, dispatch: Dispatcher<Msg['kind']>): JSX.Element | null;
    init?(model: Model, dispatch: Dispatcher<Msg['kind']>): void;
    props?(props: Props, dispatch: Dispatcher<Msg['kind']>): void;
}
export declare function component<Model, Msg extends Message<any>, Props = {}>(comp: ComponentDefinition<Model, Msg, Props>): ComponentConstructor<Props, Model>;
