var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { Component } from 'preact';
import { isCmdDispatch } from './cmd';
function runUpdate(comp, dispatch, model, msg) {
    var res = comp.update(model, msg);
    var newModel;
    if (isCmdDispatch(res)) {
        newModel = res[0];
        res[1](dispatch);
    }
    else {
        newModel = res;
    }
    return newModel;
}
export function component(comp) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, args) || this;
            _this.dispatchers = new Map();
            _this.dispatch = function (kind) {
                var dispatcher = _this.dispatchers.get(kind);
                if (dispatcher == null) {
                    dispatcher = function (value, err) {
                        var msg = { kind: kind, value: value, error: err };
                        if (value instanceof Event && value.target instanceof HTMLInputElement) {
                            switch (value.target.type) {
                                case 'checkbox':
                                    msg = __assign({}, msg, { value: value.target.checked });
                                    break;
                                default:
                                    msg = __assign({}, msg, { value: value.target.value });
                                    break;
                            }
                        }
                        _this.replaceState(runUpdate(comp, _this.dispatch, _this.state, msg));
                    };
                    _this.dispatchers.set(kind, dispatcher);
                }
                return dispatcher;
            };
            var state = runUpdate(comp, _this.dispatch, undefined, {
                kind: -1,
                value: undefined,
                error: undefined,
            });
            // Clone the initial state onto the state object
            // to avoid preact from mutating the initial state
            // on later calls to setState
            _this.state = __assign({}, state);
            return _this;
        }
        class_1.prototype.componentWillMount = function () {
            if (comp.props != null) {
                comp.props(this.props, this.dispatch);
            }
        };
        class_1.prototype.componentDidMount = function () {
            if (comp.init != null) {
                comp.init(this.state, this.dispatch);
            }
        };
        class_1.prototype.componentWillReceiveProps = function (props) {
            // TODO: only if changed?
            if (comp.props != null) {
                comp.props(props, this.dispatch);
            }
        };
        // Copied from preact-compat
        class_1.prototype.replaceState = function (state, callback) {
            this.setState(state, callback);
            for (var i in this.state) {
                if (!(i in state)) {
                    delete this.state[i];
                }
            }
        };
        class_1.prototype.render = function () {
            return comp.view(this.state, this.dispatch);
        };
        return class_1;
    }(Component));
}
